package ru.alphatech.icfpc.policy;

import java.util.ArrayList;

import ru.alphatech.icfpc.game.Batch;
import ru.alphatech.icfpc.game.Slot;


public class AttackHelpDelayPolicy extends AttackHelpPolicy{
	
	private int registerFor3thParam = 2;

	/**
	 * Сохранить как функцию в ячейке
	 * При этом последний аргумент будет ссылать на регистр
	 * пользователь сам должен менят регистр когда ему это понадобиться
	 * первые 2 параметра статичны
	 * @param type 
	 * @param processingSlot
	 * @param donor
	 * @param target
	 * @param registerFor3thParam - номер регистра (не слота)
	 */
	public AttackHelpDelayPolicy(TYPE type, int processingSlot, int donor, int target, int registerFor3thParam) {
		super(type, processingSlot, donor, target, -1);
		this.registerFor3thParam = registerFor3thParam;
	}
	
	protected ArrayList<Batch> registerChangingBatches(Slot processingSlot){
		return new ArrayList<Batch>();
	}
	
	protected int get3thRegisterIndex(){
		return registerFor3thParam;
	}
	
	protected boolean execute(){
		return false;
	}
}
